<!doctype html>
<html lang="en" class="no-js">
<head>
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<link href='http://fonts.googleapis.com/css?family=Open+Sans:400,300,600,700' rel='stylesheet' type='text/css'>

	<link rel="stylesheet" href="css/reset.css"> <!-- CSS reset -->
	<link rel="stylesheet" href="css/style.css"> <!-- Resource style -->
	<script src="js/modernizr.js"></script> <!-- Modernizr -->
	<title>Frequently Asked Questions</title>
</head>
<body>
<header>
	<h1>Frequently Asked Questions</h1>
</header>
<section class="cd-faq">
	<div class="cd-faq-items">
		<ul id="basics" class="cd-faq-group">			
		
							<li>
				<a class="cd-faq-trigger" href="#0">IS THIS COURSE LICENSED BY THE NEVADA DMV?</a>
				<div class="cd-faq-content">
					<p>Yes.</p><br>
					<p>This course is licensed by the Nevada Division of Motor Vehicles (DMV) for their <span style="font-weight:bold;">Traffic Safety School (TSS).</span> People take this course to remove points from their driving record, or to otherwise satisfy the court requirement set forth by the judge.<br><br>
					License #TSS000049322
					
					
					</p>
				</div> <!-- cd-faq-content -->
			</li>
		
		
		
			<li>
				<a class="cd-faq-trigger" href="#0">HOW MUCH IS THE COURSE?</a>
				<div class="cd-faq-content">
					<p>$9. This includes everything: the course, the test (unlimited chances to pass), and your certificate and DMV form.</p>
				</div> <!-- cd-faq-content -->
			</li>

			<li>
				<a class="cd-faq-trigger" href="#0">ARE YOU SURE THERE ARE NO HIDDEN COSTS?</a>
				<div class="cd-faq-content">
					<p>Yes.</p>
				</div> <!-- cd-faq-content -->
			</li>

			<li>
				<a class="cd-faq-trigger" href="#0">I REALLY WANT THIS CONFIRMED...IS IT REALLY JUST $9?</a>
				<div class="cd-faq-content">
					<p>Yes. Confirmed.</p>
				</div> <!-- cd-faq-content -->
			</li>

			<li>
				<a class="cd-faq-trigger" href="#0">HOW LONG IS THE COURSE?</a>
				<div class="cd-faq-content">
					<p>There are 2 courses, depending on your requirements. One couse is 5 hours, and the other is 8 hours. The court or DMV can help you determine which one you need.</p>
				</div> <!-- cd-faq-content -->
			</li>
            
            <li>
				<a class="cd-faq-trigger" href="#0">WHAT ABOUT FEES FOR MISTAKES?</a>
				<div class="cd-faq-content">
					<p>We're glad you asked!<br><br>
					<span style="font-weight:bold;">There is a $10 fee for mistakes in your profile.</span> If you make a mistake on your profile, then our team must go into the system and manually make another certificate for you. For this, we charge $10. We had our techs add some check boxes on the profile intake form to prevent mistakes, including a box that warns you about the $10 fee, because we would rather not have the hassle. We are pleased to report that since those checkboxes have been added, seldom is a mistake made. </p><br>
					<p>Some people complain that the mistake fee is higher than the course. The VALUE of the course is about $40. This corporation (Online CE LLC) was the first company to bring the prices down, without forfeiting value. All courses provided by Online CE LLC, throughout the country, have the same fee for profile mistakes. That cost was chosen by determining the lowest amount that would make people look over their profile again, before entering the information. Even if you are one of the very few who make a mistake in your profile, you are still getting a tremendous deal.</p>
				</div> <!-- cd-faq-content -->
			</li>
            
            <li>
				<a class="cd-faq-trigger" href="#0">HOW DOES THIS WORK?</a>
				<div class="cd-faq-content">
					<p>It's easy!<br><br>
1. Click the button that says <span style="font-weight:bold;font-style:italic;">Enter the Course</span>, and you will be taken to a page to create your profile. You will be taken to a page where you will confirm your account online, and then you can begin the course.<br><br>
2. Take the course at your own pace, and take the test as many times as you need to pass. Come and go as you please. There is no time limit, and you will not lose any time accrued.<br><br>
3. When the test is done, you will be presented with a a link to download your "Proof of Attendance" form. This form is required by the Nevada DMV, so all approved schools must require it. <br>
<span style="margin-left: .5in;">a) Download and fill that form out.</span><br>
<span style="margin-left: .5in;">b) Get the form NOTARIZED. Again, the notary is required by the Nevada DMV.</span><br>
<span style="margin-left: .5in;">c) Send us a photo of the form so we can get a jump start on your paperwork.</span><br>
<span style="margin-left: .5in;">d) Mail us the hard copy of the notarized form, because we cannot legally send you your paperwork until we have that.</span><br><br>
After we get the notarized form in the mail, we will email you your paperwork within 3 business days. You will get it much more quickly by first emailing us a photo of the notarized form. Most people get the paperwork on the day that the notarized form arrives in the mail.</p>

				</div> <!-- cd-faq-content -->
			</li>

 
            
            <li>
				<a class="cd-faq-trigger" href="#0">DO I HAVE TO TAKE THE COURSE ALL IN ONE SITTING? CAN I LEAVE AND COME BACK?</a>
				<div class="cd-faq-content">
					<p>You do NOT have to take the course all at once. Come and go as you please. You keep all the the time you have already spent in the course, so you lose nothing by leaving and then returning later. Also, you get unlimited chances to pass the test.<br><br>
When you pass the test, your certificate available immediately through a download button that you will see. </p>
				</div> <!-- cd-faq-content -->
			</li>
		</ul> <!-- cd-faq-group -->
<p> </p><br>
		<p style="margin-bottom: 0in; text-align: center;"><span style="font-size: xx-large;">If your question is not found in FAQ, then <a href="../contactus.php"><span style="color: #DC143C;"><b><u><b>click here to contact us</b><u/></a></span></span></p>
	</div> <!-- cd-faq-items -->
	<a href="#0" class="cd-close-panel">Close</a>
</section> <!-- cd-faq -->

<script src="js/jquery-2.1.1.js"></script>
<script src="js/jquery.mobile.custom.min.js"></script>
<script src="js/main.js"></script> <!-- Resource jQuery -->
</body>
</html>